##// END OF EJS Templates
removed the usb part from ubootusb
Unknown -
r541:fa11a3c0304b
parent child
Show More
@@ -1,99 +1,113
1 1 #
2 2 # Setup fstab and initramfs
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Install and setup fstab
9 9 install_readonly files/mount/fstab "${ETC_DIR}/fstab"
10 10
11 if [ "$ENABLE_UBOOTUSB" = true ] ; then
11 if [ "$ENABLE_USBBOOT" = true ] ; then
12 12 sed -i "s/mmcblk0p1/sda1/" "${ETC_DIR}/fstab"
13 13 sed -i "s/mmcblk0p2/sda2/" "${ETC_DIR}/fstab"
14 14 fi
15 15
16 16 # Add usb/sda disk root partition to fstab
17 17 if [ "$ENABLE_SPLITFS" = true ] && [ "$ENABLE_CRYPTFS" = false ] ; then
18 18 sed -i "s/mmcblk0p2/sda1/" "${ETC_DIR}/fstab"
19 19 fi
20 20
21 21 # Add encrypted root partition to fstab and crypttab
22 22 if [ "$ENABLE_CRYPTFS" = true ] ; then
23 23 # Replace fstab root partition with encrypted partition mapping
24 24 sed -i "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING}/" "${ETC_DIR}/fstab"
25 25
26 26 # Add encrypted partition to crypttab and fstab
27 27 install_readonly files/mount/crypttab "${ETC_DIR}/crypttab"
28 28 echo "${CRYPTFS_MAPPING} /dev/mmcblk0p2 none luks" >> "${ETC_DIR}/crypttab"
29 29
30 30 if [ "$ENABLE_SPLITFS" = true ] ; then
31 31 # Add usb/sda disk to crypttab
32 32 sed -i "s/mmcblk0p2/sda1/" "${ETC_DIR}/crypttab"
33 33 fi
34 34 fi
35 35
36 36 # Generate initramfs file
37 37 if [ "$ENABLE_INITRAMFS" = true ] ; then
38 38 if [ "$ENABLE_CRYPTFS" = true ] ; then
39 39 # Include initramfs scripts to auto expand encrypted root partition
40 40 if [ "$EXPANDROOT" = true ] ; then
41 41 install_exec files/initramfs/expand_encrypted_rootfs "${ETC_DIR}/initramfs-tools/scripts/init-premount/expand_encrypted_rootfs"
42 42 install_exec files/initramfs/expand-premount "${ETC_DIR}/initramfs-tools/scripts/local-premount/expand-premount"
43 43 install_exec files/initramfs/expand-tools "${ETC_DIR}/initramfs-tools/hooks/expand-tools"
44 44 fi
45 45
46 46 if [ "$CRYPTFS_DROPBEAR" = true ]; then
47 # Get cdir from NET_ADDRESS e.g. 24
48 cdir=$(${NET_ADDRESS} | cut -d '/' -f2)
49
50 # Convert cdir ro netmask e.g. 24 to 255.255.255.0
51 NET_MASK=$(cdr2mask "$cdir")
52
53 # Write static ip settings to "${ETC_DIR}"/initramfs-tools/initramfs.conf
54 sed -i "\$aIP=${NET_ADDRESS}::${NET_GATEWAY}:${NET_MASK}:${HOSTNAME}:" "${ETC_DIR}"/initramfs-tools/initramfs.conf
55
56 # Regenerate initramfs
57 chroot_exec mkinitramfs -o "/boot/firmware/initramfs-${KERNEL_VERSION}" "${KERNEL_VERSION}"
58 fi
59
60 if [ "$CRYPTFS_DROPBEAR" = true ]; then
47 61 if [ -n "$CRYPTFS_DROPBEAR_PUBKEY" ] && [ -f "$CRYPTFS_DROPBEAR_PUBKEY" ] ; then
48 62 install_readonly "${CRYPTFS_DROPBEAR_PUBKEY}" "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub
49 63 cat "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub >> "${ETC_DIR}"/dropbear-initramfs/authorized_keys
50 64 else
51 65 # Create key
52 66 chroot_exec /usr/bin/dropbearkey -t rsa -f /etc/dropbear-initramfs/id_rsa.dropbear
53 67
54 68 # Convert dropbear key to openssh key
55 69 chroot_exec /usr/lib/dropbear/dropbearconvert dropbear openssh /etc/dropbear-initramfs/id_rsa.dropbear /etc/dropbear-initramfs/id_rsa
56 70
57 71 # Get Public Key Part
58 72 chroot_exec /usr/bin/dropbearkey -y -f /etc/dropbear-initramfs/id_rsa.dropbear | chroot_exec tee /etc/dropbear-initramfs/id_rsa.pub
59 73
60 74 # Delete unwanted lines
61 75 sed -i '/Public/d' "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub
62 76 sed -i '/Fingerprint/d' "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub
63 77
64 78 # Trust the new key
65 79 cat "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub > "${ETC_DIR}"/dropbear-initramfs/authorized_keys
66 80
67 81 # Save Keys - convert with putty from rsa/openssh to puttkey
68 82 cp -f "${ETC_DIR}"/dropbear-initramfs/id_rsa "${BASEDIR}"/dropbear_initramfs_key.rsa
69 83
70 84 # Get unlock script
71 85 install_exec files/initramfs/crypt_unlock.sh "${ETC_DIR}"/initramfs-tools/hooks/crypt_unlock.sh
72 86
73 87 # Enable Dropbear inside initramfs
74 88 printf "#\n# DROPBEAR: [ y | n ]\n#\n\nDROPBEAR=y\n" >> "${ETC_DIR}/initramfs-tools/initramfs.conf"
75 89
76 90 # Enable Dropbear inside initramfs
77 91 sed -i "54 i sleep 5" "${R}"/usr/share/initramfs-tools/scripts/init-premount/dropbear
78 92 fi
79 93 else
80 94 # Disable SSHD inside initramfs
81 95 printf "#\n# DROPBEAR: [ y | n ]\n#\n\nDROPBEAR=n\n" >> "${ETC_DIR}/initramfs-tools/initramfs.conf"
82 96 fi
83 97
84 98 # Add cryptsetup modules to initramfs
85 99 printf "#\n# CRYPTSETUP: [ y | n ]\n#\n\nCRYPTSETUP=y\n" >> "${ETC_DIR}/initramfs-tools/conf-hook"
86 100
87 101 # Dummy mapping required by mkinitramfs
88 102 echo "0 1 crypt $(echo "${CRYPTFS_CIPHER}" | cut -d ':' -f 1) ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff 0 7:0 4096" | chroot_exec dmsetup create "${CRYPTFS_MAPPING}"
89 103
90 104 # Generate initramfs with encrypted root partition support
91 105 chroot_exec mkinitramfs -o "/boot/firmware/initramfs-${KERNEL_VERSION}" "${KERNEL_VERSION}"
92 106
93 107 # Remove dummy mapping
94 108 chroot_exec cryptsetup close "${CRYPTFS_MAPPING}"
95 109 else
96 110 # Generate initramfs without encrypted root partition support
97 111 chroot_exec mkinitramfs -o "/boot/firmware/initramfs-${KERNEL_VERSION}" "${KERNEL_VERSION}"
98 112 fi
99 113 fi
@@ -1,289 +1,289
1 1 #
2 2 # Setup RPi2/3 config and cmdline
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
9 9 # Install boot binaries from local directory
10 10 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
11 11 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
12 12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
13 13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
14 14 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
15 15 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
16 16 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
17 17 else
18 18 # Create temporary directory for boot binaries
19 19 temp_dir=$(as_nobody mktemp -d)
20 20
21 21 # Install latest boot binaries from raspberry/firmware github
22 22 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
23 23 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
24 24 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
25 25 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
26 26 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
27 27 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
28 28 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
29 29
30 30 # Move downloaded boot binaries
31 31 mv "${temp_dir}/"* "${BOOT_DIR}/"
32 32
33 33 # Remove temporary directory for boot binaries
34 34 rm -fr "${temp_dir}"
35 35
36 36 # Set permissions of the boot binaries
37 37 chown -R root:root "${BOOT_DIR}"
38 38 chmod -R 600 "${BOOT_DIR}"
39 39 fi
40 40
41 41 if [ "$ENABLE_KEYGEN" = true] ; then
42 42
43 43 # go to chroot/boot/
44 44 cd "${BOOT_DIR}/" || exit
45 45
46 46 # Make a copy of start.elf
47 47 cp start.elf start.elf_backup
48 48
49 49 # Remove codec licence checks - thx go to https://github.com/nucular/raspi-keygen - if ENABLE_VIDEOCORE is true, you can check codec status https://elinux.org/RPI_vcgencmd_usage
50 50 perl -pne 's/\x47\xE9362H\x3C\x18/\x47\xE9362H\x3C\x1F/g' < start.elf_backup > start.elf
51 51
52 52 # Back to base dir
53 53 cd "${WORKDIR}" || exit
54 54 fi
55 55
56 56 # Setup firmware boot cmdline
57 if [ "$ENABLE_UBOOTUSB" = true ] ; then
57 if [ "$ENABLE_USBBOOT" = true ] ; then
58 58 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait init=/bin/systemd"
59 59 else
60 60 if [ "$ENABLE_SPLITFS" = true ] ; then
61 61 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait init=/bin/systemd"
62 62 else
63 63 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait init=/bin/systemd"
64 64 fi
65 65 fi
66 66
67 67 # Add encrypted root partition to cmdline.txt
68 68 if [ "$ENABLE_CRYPTFS" = true ] ; then
69 69 if [ "$ENABLE_SPLITFS" = true ] ; then
70 70 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
71 71 else
72 if [ "$ENABLE_UBOOTUSB" = true ] ; then
72 if [ "$ENABLE_USBBOOT" = true ] ; then
73 73 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
74 74 else
75 75 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
76 76 fi
77 77 fi
78 78 fi
79 79
80 80 # Enable Kernel messages on standard output
81 81 if [ "$ENABLE_PRINTK" = true ] ; then
82 82 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
83 83 fi
84 84
85 85 # Enable Kernel messages on standard output
86 86 if [ "$KERNEL_SECURITY" = true ] ; then
87 87 install_readonly files/sysctl.d/84-rpi-ASLR.conf "${ETC_DIR}/sysctl.d/84-rpi-ASLR.conf"
88 88 fi
89 89
90 90 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
91 91 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
92 92
93 93 # Remove IPv6 networking support
94 94 if [ "$ENABLE_IPV6" = false ] ; then
95 95 CMDLINE="${CMDLINE} ipv6.disable=1"
96 96 fi
97 97
98 98 # Automatically assign predictable network interface names
99 99 if [ "$ENABLE_IFNAMES" = false ] ; then
100 100 CMDLINE="${CMDLINE} net.ifnames=0"
101 101 else
102 102 CMDLINE="${CMDLINE} net.ifnames=1"
103 103 fi
104 104
105 105 # Install firmware config
106 106 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
107 107
108 108 # Locks CPU frequency at maximum
109 109 if [ "$ENABLE_TURBO" = true ] ; then
110 110 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
111 111 # helps to avoid sdcard corruption when force_turbo is enabled.
112 112 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
113 113 fi
114 114
115 115 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
116 116
117 117 # Bluetooth enabled
118 118 if [ "$ENABLE_BLUETOOTH" = true ] ; then
119 119 # Create temporary directory for Bluetooth sources
120 120 temp_dir=$(as_nobody mktemp -d)
121 121
122 122 # Fetch Bluetooth sources
123 123 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
124 124
125 125 # Copy downloaded sources
126 126 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
127 127
128 128 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
129 129 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
130 130 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://aur.archlinux.org/cgit/aur.git/plain/BCM43430A1.hcd?h=pi-bluetooth
131 131
132 132 # Set permissions
133 133 chown -R root:root "${R}/tmp/pi-bluetooth"
134 134
135 135 # Install tools
136 136 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
137 137 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
138 138
139 139 # make scripts executable
140 140 chmod +x "${R}/usr/bin/bthelper"
141 141 chmod +x "${R}/usr/bin/btuart"
142 142
143 143 # Install bluetooth udev rule
144 144 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
145 145
146 146 # Install Firmware Flash file and apropiate licence
147 147 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
148 148 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
149 149 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
150 150 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
151 151 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
152 152
153 153 # Remove temporary directories
154 154 rm -fr "${temp_dir}"
155 155 rm -fr "${R}"/tmp/pi-bluetooth
156 156
157 157 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
158 158 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
159 159
160 160 # set overlay to swap ttyAMA0 and ttyS0
161 161 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
162 162
163 163 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
164 164 if [ "$ENABLE_TURBO" = false ] ; then
165 165 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
166 166 fi
167 167 fi
168 168
169 169 # Activate services
170 170 chroot_exec systemctl enable pi-bluetooth.hciuart.service
171 171
172 172 else # if ENABLE_BLUETOOTH = false
173 173 # set overlay to disable bluetooth
174 174 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
175 175 fi # ENABLE_BLUETOOTH end
176 176 fi
177 177
178 178 # may need sudo systemctl disable hciuart
179 179 if [ "$ENABLE_CONSOLE" = true ] ; then
180 180 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
181 181 # add string to cmdline
182 182 CMDLINE="${CMDLINE} console=serial0,115200"
183 183
184 184 # Enable serial console systemd style
185 185 chroot_exec systemctl enable serial-getty\@serial0.service
186 186 else
187 187 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
188 188 fi
189 189
190 190 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
191 191 # Create temporary directory for systemd-swap sources
192 192 temp_dir=$(as_nobody mktemp -d)
193 193
194 194 # Fetch systemd-swap sources
195 195 as_nobody git -C "${temp_dir}" clone "${SYSTEMDSWAP_URL}"
196 196
197 197 # Copy downloaded systemd-swap sources
198 198 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
199 199
200 200 # Change into downloaded src dir
201 201 cd "${R}/tmp/systemd-swap" || exit
202 202
203 203 # Build package
204 204 bash ./package.sh debian
205 205
206 206 # Change back into script root dir
207 207 cd "${WORKDIR}" || exit
208 208
209 209 # Set permissions of the systemd-swap sources
210 210 chown -R root:root "${R}/tmp/systemd-swap"
211 211
212 212 # Install package - IMPROVE AND MAKE IT POSSIBLE WITHOUT VERSION NR.
213 213 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap_4.0.1_any.deb
214 214
215 215 # Enable service
216 216 chroot_exec systemctl enable systemd-swap
217 217
218 218 # Remove temporary directory for systemd-swap sources
219 219 rm -fr "${temp_dir}"
220 220 else
221 221 # Enable ZSWAP in cmdline if systemd-swap is not used
222 222 if [ "$KERNEL_ZSWAP" = true ] ; then
223 223 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
224 224 fi
225 225 fi
226 226 if [ "$KERNEL_SECURITY" = true ] ; then
227 227 CMDLINE="${CMDLINE} apparmor=1 security=apparmor"
228 228 fi
229 229
230 230 # Install firmware boot cmdline
231 231 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
232 232
233 233 # Setup minimal GPU memory allocation size: 16MB (no X)
234 234 if [ "$ENABLE_MINGPU" = true ] ; then
235 235 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
236 236 fi
237 237
238 238 # Setup boot with initramfs
239 239 if [ "$ENABLE_INITRAMFS" = true ] ; then
240 240 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
241 241 fi
242 242
243 243 # Create firmware configuration and cmdline symlinks
244 244 ln -sf firmware/config.txt "${R}/boot/config.txt"
245 245 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
246 246
247 247 # Install and setup kernel modules to load at boot
248 248 mkdir -p "${LIB_DIR}/modules-load.d/"
249 249 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
250 250
251 251 # Load hardware random module at boot
252 252 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
253 253 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
254 254 fi
255 255
256 256 # Load sound module at boot
257 257 if [ "$ENABLE_SOUND" = true ] ; then
258 258 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
259 259 else
260 260 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
261 261 fi
262 262
263 263 # Enable I2C interface
264 264 if [ "$ENABLE_I2C" = true ] ; then
265 265 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
266 266 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
267 267 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
268 268 fi
269 269
270 270 # Enable SPI interface
271 271 if [ "$ENABLE_SPI" = true ] ; then
272 272 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
273 273 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
274 274 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
275 275 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
276 276 fi
277 277 fi
278 278
279 279 # Disable RPi2/3 under-voltage warnings
280 280 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
281 281 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
282 282 fi
283 283
284 284 # Install kernel modules blacklist
285 285 mkdir -p "${ETC_DIR}/modprobe.d/"
286 286 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
287 287
288 288 # Install sysctl.d configuration files
289 289 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
@@ -1,146 +1,132
1 1 #
2 2 # Setup Networking
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Install and setup hostname
9 9 install_readonly files/network/hostname "${ETC_DIR}/hostname"
10 10 sed -i "s/^RaspberryPI/${HOSTNAME}/" "${ETC_DIR}/hostname"
11 11
12 12 # Install and setup hosts
13 13 install_readonly files/network/hosts "${ETC_DIR}/hosts"
14 14 sed -i "s/RaspberryPI/${HOSTNAME}/" "${ETC_DIR}/hosts"
15 15
16 16 # Setup hostname entry with static IP
17 17 if [ "$NET_ADDRESS" != "" ] ; then
18 18 NET_IP=$(echo "${NET_ADDRESS}" | cut -f 1 -d'/')
19 19 sed -i "s/^127.0.1.1/${NET_IP}/" "${ETC_DIR}/hosts"
20 20 fi
21 21
22 22 # Remove IPv6 hosts
23 23 if [ "$ENABLE_IPV6" = false ] ; then
24 24 sed -i -e "/::[1-9]/d" -e "/^$/d" "${ETC_DIR}/hosts"
25 25 fi
26 26
27 27 # Install hint about network configuration
28 28 install_readonly files/network/interfaces "${ETC_DIR}/network/interfaces"
29 29
30 30 # Install configuration for interface eth0
31 31 install_readonly files/network/eth.network "${ETC_DIR}/systemd/network/eth.network"
32 32
33 33 # Install configuration for interface wl*
34 34 install_readonly files/network/wlan.network "${ETC_DIR}/systemd/network/wlan.network"
35 35
36 36 #always with dhcp since wpa_supplicant integration is missing
37 37 sed -i -e "s/DHCP=.*/DHCP=yes/" -e "/DHCP/q" "${ETC_DIR}/systemd/network/wlan.network"
38 38
39 39 if [ "$ENABLE_DHCP" = true ] ; then
40 40 # Enable DHCP configuration for interface eth0
41 41 sed -i -e "s/DHCP=.*/DHCP=yes/" -e "/DHCP/q" "${ETC_DIR}/systemd/network/eth.network"
42 42
43 43 # Set DHCP configuration to IPv4 only
44 44 if [ "$ENABLE_IPV6" = false ] ; then
45 45 sed -i "s/DHCP=.*/DHCP=v4/" "${ETC_DIR}/systemd/network/eth.network"
46 46 fi
47 47
48 48 else # ENABLE_DHCP=false
49 49 # Set static network configuration for interface eth0
50 50 sed -i\
51 51 -e "s|DHCP=.*|DHCP=no|"\
52 52 -e "s|Address=\$|Address=${NET_ADDRESS}|"\
53 53 -e "s|Gateway=\$|Gateway=${NET_GATEWAY}|"\
54 54 -e "0,/DNS=\$/ s|DNS=\$|DNS=${NET_DNS_1}|"\
55 55 -e "0,/DNS=\$/ s|DNS=\$|DNS=${NET_DNS_2}|"\
56 56 -e "s|Domains=\$|Domains=${NET_DNS_DOMAINS}|"\
57 57 -e "0,/NTP=\$/ s|NTP=\$|NTP=${NET_NTP_1}|"\
58 58 -e "0,/NTP=\$/ s|NTP=\$|NTP=${NET_NTP_2}|"\
59 59 "${ETC_DIR}/systemd/network/eth.network"
60
61 if [ "$CRYPTFS_DROPBEAR" = true ] ; then
62 # Get cdir from NET_ADDRESS e.g. 24
63 cdir=$(${NET_ADDRESS} | cut -d '/' -f2)
64
65 # Convert cdir ro netmask e.g. 24 to 255.255.255.0
66 NET_MASK=$(cdr2mask "$cdir")
67
68 # Write static ip settings to "${ETC_DIR}"/initramfs-tools/initramfs.conf
69 sed -i "\$aIP=${NET_ADDRESS}::${NET_GATEWAY}:${NET_MASK}:${HOSTNAME}:" "${ETC_DIR}"/initramfs-tools/initramfs.conf
70
71 # Regenerate initramfs
72 chroot_exec mkinitramfs -o "/boot/firmware/initramfs-${KERNEL_VERSION}" "${KERNEL_VERSION}"
73 fi
74 60 fi
75 61
76 62 # Remove empty settings from network configuration
77 63 sed -i "/.*=\$/d" "${ETC_DIR}/systemd/network/eth.network"
78 64 # Remove empty settings from wlan configuration
79 65 sed -i "/.*=\$/d" "${ETC_DIR}/systemd/network/wlan.network"
80 66
81 67 # Move systemd network configuration if required by Debian release
82 68 mv -v "${ETC_DIR}/systemd/network/eth.network" "${LIB_DIR}/systemd/network/10-eth.network"
83 69 # If WLAN is enabled copy wlan configuration too
84 70 if [ "$ENABLE_WIRELESS" = true ] ; then
85 71 mv -v "${ETC_DIR}/systemd/network/wlan.network" "${LIB_DIR}/systemd/network/11-wlan.network"
86 72 fi
87 73 rm -fr "${ETC_DIR}/systemd/network"
88 74
89 75 # Enable systemd-networkd service
90 76 chroot_exec systemctl enable systemd-networkd
91 77
92 78 # Install host.conf resolver configuration
93 79 install_readonly files/network/host.conf "${ETC_DIR}/host.conf"
94 80
95 81 # Enable network stack hardening
96 82 if [ "$ENABLE_HARDNET" = true ] ; then
97 83 # Install sysctl.d configuration files
98 84 install_readonly files/sysctl.d/82-rpi-net-hardening.conf "${ETC_DIR}/sysctl.d/82-rpi-net-hardening.conf"
99 85
100 86 # Setup resolver warnings about spoofed addresses
101 87 sed -i "s/^# spoof warn/spoof warn/" "${ETC_DIR}/host.conf"
102 88 fi
103 89
104 90 # Enable time sync
105 91 if [ "$NET_NTP_1" != "" ] ; then
106 92 chroot_exec systemctl enable systemd-timesyncd.service
107 93 fi
108 94
109 95 # Download the firmware binary blob required to use the RPi3 wireless interface
110 96 if [ "$ENABLE_WIRELESS" = true ] ; then
111 97 if [ ! -d "${WLAN_FIRMWARE_DIR}" ] ; then
112 98 mkdir -p "${WLAN_FIRMWARE_DIR}"
113 99 fi
114 100
115 101 # Create temporary directory for firmware binary blob
116 102 temp_dir=$(as_nobody mktemp -d)
117 103
118 104 # Fetch firmware binary blob for RPI3B+
119 105 if [ "$RPI_MODEL" = 3P ] ; then
120 106 # Fetch firmware binary blob for RPi3P
121 107 as_nobody wget -q -O "${temp_dir}/brcmfmac43455-sdio.bin" "${WLAN_FIRMWARE_URL}/brcmfmac43455-sdio.bin"
122 108 as_nobody wget -q -O "${temp_dir}/brcmfmac43455-sdio.txt" "${WLAN_FIRMWARE_URL}/brcmfmac43455-sdio.txt"
123 109 as_nobody wget -q -O "${temp_dir}/brcmfmac43455-sdio.clm_blob" "${WLAN_FIRMWARE_URL}/brcmfmac43455-sdio.clm_blob"
124 110
125 111 # Move downloaded firmware binary blob
126 112 mv "${temp_dir}/brcmfmac43455-sdio."* "${WLAN_FIRMWARE_DIR}/"
127 113
128 114 # Set permissions of the firmware binary blob
129 115 chown root:root "${WLAN_FIRMWARE_DIR}/brcmfmac43455-sdio."*
130 116 chmod 600 "${WLAN_FIRMWARE_DIR}/brcmfmac43455-sdio."*
131 117 elif [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 0 ] ; then
132 118 # Fetch firmware binary blob for RPi3
133 119 as_nobody wget -q -O "${temp_dir}/brcmfmac43430-sdio.bin" "${WLAN_FIRMWARE_URL}/brcmfmac43430-sdio.bin"
134 120 as_nobody wget -q -O "${temp_dir}/brcmfmac43430-sdio.txt" "${WLAN_FIRMWARE_URL}/brcmfmac43430-sdio.txt"
135 121
136 122 # Move downloaded firmware binary blob
137 123 mv "${temp_dir}/brcmfmac43430-sdio."* "${WLAN_FIRMWARE_DIR}/"
138 124
139 125 # Set permissions of the firmware binary blob
140 126 chown root:root "${WLAN_FIRMWARE_DIR}/brcmfmac43430-sdio."*
141 127 chmod 600 "${WLAN_FIRMWARE_DIR}/brcmfmac43430-sdio."*
142 128 fi
143 129
144 130 # Remove temporary directory for firmware binary blob
145 131 rm -fr "${temp_dir}"
146 132 fi
@@ -1,882 +1,884
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63
64 64 # Kernel deb packages for 32bit kernel
65 65 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 66 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 67 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 68 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
69 69 # Default precompiled 64bit kernel
70 70 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
71 71 # Generic
72 72 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
73 73 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
74 74 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
75 75
76 76 # Build directories
77 77 WORKDIR=$(pwd)
78 78 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
79 79 BUILDDIR="${BASEDIR}/build"
80 80
81 81 # Chroot directories
82 82 R="${BUILDDIR}/chroot"
83 83 ETC_DIR="${R}/etc"
84 84 LIB_DIR="${R}/lib"
85 85 BOOT_DIR="${R}/boot/firmware"
86 86 KERNEL_DIR="${R}/usr/src/linux"
87 87 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
88 88 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
89 89
90 90 # Firmware directory: Blank if download from github
91 91 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
92 92
93 93 # General settings
94 94 SET_ARCH=${SET_ARCH:=32}
95 95 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
96 96 PASSWORD=${PASSWORD:=raspberry}
97 97 USER_PASSWORD=${USER_PASSWORD:=raspberry}
98 98 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
99 99 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
100 100 EXPANDROOT=${EXPANDROOT:=true}
101 101
102 102 # Keyboard settings
103 103 XKB_MODEL=${XKB_MODEL:=""}
104 104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 105 XKB_VARIANT=${XKB_VARIANT:=""}
106 106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107 107
108 108 # Network settings (DHCP)
109 109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110 110
111 111 # Network settings (static)
112 112 NET_ADDRESS=${NET_ADDRESS:=""}
113 113 NET_GATEWAY=${NET_GATEWAY:=""}
114 114 NET_DNS_1=${NET_DNS_1:=""}
115 115 NET_DNS_2=${NET_DNS_2:=""}
116 116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 117 NET_NTP_1=${NET_NTP_1:=""}
118 118 NET_NTP_2=${NET_NTP_2:=""}
119 119
120 120 # APT settings
121 121 APT_PROXY=${APT_PROXY:=""}
122 122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123 123
124 124 # Feature settings
125 125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 129 ENABLE_I2C=${ENABLE_I2C:=false}
130 130 ENABLE_SPI=${ENABLE_SPI:=false}
131 131 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 132 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 135 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 136 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 139 ENABLE_XORG=${ENABLE_XORG:=false}
140 140 ENABLE_WM=${ENABLE_WM:=""}
141 141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 142 ENABLE_USER=${ENABLE_USER:=true}
143 143 USER_NAME=${USER_NAME:="pi"}
144 144 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 145 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 147 ENABLE_KEYGEN=${ENABLE_KEYGEN:=true}
148 148
149 149 # SSH settings
150 150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155 155
156 156 # Advanced settings
157 157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 174 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
175 175
176 176 # Kernel compilation settings
177 177 BUILD_KERNEL=${BUILD_KERNEL:=true}
178 178 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
179 179 KERNEL_THREADS=${KERNEL_THREADS:=1}
180 180 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
181 181 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
182 182 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
183 183 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
184 184 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
185 185 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
186 186 KERNEL_VIRT=${KERNEL_VIRT:=false}
187 187 KERNEL_BPF=${KERNEL_BPF:=false}
188 188 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
189 189 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
190 190 KERNEL_NF=${KERNEL_NF:=false}
191 191
192 192 # Kernel compilation from source directory settings
193 193 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
194 194 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
195 195 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
196 196 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
197 197
198 198 # Reduce disk usage settings
199 199 REDUCE_APT=${REDUCE_APT:=true}
200 200 REDUCE_DOC=${REDUCE_DOC:=true}
201 201 REDUCE_MAN=${REDUCE_MAN:=true}
202 202 REDUCE_VIM=${REDUCE_VIM:=false}
203 203 REDUCE_BASH=${REDUCE_BASH:=false}
204 204 REDUCE_HWDB=${REDUCE_HWDB:=true}
205 205 REDUCE_SSHD=${REDUCE_SSHD:=true}
206 206 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
207 207
208 208 # Encrypted filesystem settings
209 209 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
210 210 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
211 211 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
212 212 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
213 213 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
214 214 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
215 215 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
216 216 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
217 217 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
218 218
219 219 # Chroot scripts directory
220 220 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
221 221
222 222 # Packages required in the chroot build environment
223 223 APT_INCLUDES=${APT_INCLUDES:=""}
224 224 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
225 225
226 226 # Packages to exclude from chroot build environment
227 227 APT_EXCLUDES=${APT_EXCLUDES:=""}
228 228
229 229 # Packages required for bootstrapping
230 230 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
231 231 MISSING_PACKAGES=""
232 232
233 233 # Packages installed for c/c++ build environment in chroot (keep empty)
234 234 COMPILER_PACKAGES=""
235 235
236 236 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
237 237 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
238 238 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
239 239 APT_PROXY=http://127.0.0.1:3142/
240 240 fi
241 241
242 242 # netselect-apt does not know buster yet
243 243 if [ "$RELEASE" = "buster" ] ; then
244 244 RLS=testing
245 245 else
246 246 RLS="$RELEASE"
247 247 fi
248 248
249 249 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
250 250 rm "$(pwd)/files/apt/sources.list"
251 251 fi
252 252
253 253 if [ "$ENABLE_NONFREE" = true ] ; then
254 254 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
255 255 else
256 256 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
257 257 fi
258 258
259 259 # sed and cut the result string so we can use it as APT_SERVER
260 260 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
261 261
262 262 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
263 263 if [ -n "$SET_ARCH" ] ; then
264 264 # 64-bit configuration
265 265 if [ "$SET_ARCH" = 64 ] ; then
266 266 # General 64-bit depended settings
267 267 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
268 268 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
269 269 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
270 270
271 271 # Raspberry Pi model specific settings
272 272 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
273 273 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
274 274 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
275 275 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
276 276 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
277 277 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
278 278 else
279 279 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
280 280 exit 1
281 281 fi
282 282 fi
283 283
284 284 # 32-bit configuration
285 285 if [ "$SET_ARCH" = 32 ] ; then
286 286 # General 32-bit dependend settings
287 287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
288 288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
289 289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
290 290
291 291 # Raspberry Pi model specific settings
292 292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
293 293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
294 294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
295 295 RELEASE_ARCH=${RELEASE_ARCH:=armel}
296 296 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
297 297 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
298 298 fi
299 299
300 300 # Raspberry Pi model specific settings
301 301 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
302 302 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
303 303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
304 304 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
305 305 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
306 306 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
307 307 fi
308 308 fi
309 309 # SET_ARCH not set
310 310 else
311 311 echo "error: Please set '32' or '64' as value for SET_ARCH"
312 312 exit 1
313 313 fi
314 314 # Device specific configuration and U-Boot configuration
315 315 case "$RPI_MODEL" in
316 316 0)
317 317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
318 318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
319 319 ;;
320 320 1)
321 321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
322 322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 323 ;;
324 324 1P)
325 325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
326 326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 327 ;;
328 328 2)
329 329 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
330 330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
331 331 ;;
332 332 3)
333 333 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
334 334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
335 335 ;;
336 336 3P)
337 337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
338 338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
339 339 ;;
340 340 *)
341 341 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
342 342 exit 1
343 343 ;;
344 344 esac
345 345
346 346 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
347 347 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
348 348 # Include bluetooth packages on supported boards
349 349 if [ "$ENABLE_BLUETOOTH" = true ] ; then
350 350 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
351 351 fi
352 352 if [ "$ENABLE_WIRELESS" = true ] ; then
353 353 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
354 354 fi
355 355 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
356 356 # Check if the internal wireless interface is not supported by the RPi model
357 357 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
358 358 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
359 359 exit 1
360 360 fi
361 361 fi
362 362
363 363 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
364 364 echo "error: You have to compile kernel sources, if you want to enable nexmon"
365 365 exit 1
366 366 fi
367 367
368 368 # Prepare date string for default image file name
369 369 DATE="$(date +%Y-%m-%d)"
370 370 if [ -z "$KERNEL_BRANCH" ] ; then
371 371 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
372 372 else
373 373 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
374 374 fi
375 375
376 376 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
377 377 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
378 378 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
379 379 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
380 380 exit 1
381 381 fi
382 382 fi
383 383
384 384 set +x
385 385
386 386 # Add cmake to compile videocore sources
387 387 if [ "$ENABLE_KEYGEN" = true ] ; then
388 388 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} perl"
389 389 fi
390 390
391 391 # Add cmake to compile videocore sources
392 392 if [ "$ENABLE_VIDEOCORE" = true ] ; then
393 393 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
394 394 fi
395 395
396 396 # Add deps for nexmon
397 397 if [ "$ENABLE_NEXMON" = true ] ; then
398 398 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
399 399 fi
400 400
401 401 # Add libncurses5 to enable kernel menuconfig
402 402 if [ "$KERNEL_MENUCONFIG" = true ] ; then
403 403 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
404 404 fi
405 405
406 406 # Add ccache compiler cache for (faster) kernel cross (re)compilation
407 407 if [ "$KERNEL_CCACHE" = true ] ; then
408 408 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
409 409 fi
410 410
411 411 # Add cryptsetup package to enable filesystem encryption
412 412 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
413 413 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
414 414 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
415 415
416 416 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
417 417 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
418 418 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
419 419 fi
420 420
421 421 if [ -z "$CRYPTFS_PASSWORD" ] ; then
422 422 echo "error: no password defined (CRYPTFS_PASSWORD)!"
423 423 exit 1
424 424 fi
425 425 ENABLE_INITRAMFS=true
426 426 fi
427 427
428 428 # Add initramfs generation tools
429 429 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
430 430 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
431 431 fi
432 432
433 433 # Add device-tree-compiler required for building the U-Boot bootloader
434 434 if [ "$ENABLE_UBOOT" = true ] ; then
435 435 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
436 #else
437 # if [ "$ENABLE_UBOOTUSB" = true ] ; then
438 # echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
439 # exit 1
440 # fi
436 fi
437
438 if [ "$ENABLE_USBBOOT" = true ] ; then
439 if ["$RPI_MODEL" != 3 ] || ["$RPI_MODEL" != 3P ] ; then
440 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
441 exit 1
442 fi
441 443 fi
442 444
443 445 # Check if root SSH (v2) public key file exists
444 446 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
445 447 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
446 448 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
447 449 exit 1
448 450 fi
449 451 fi
450 452
451 453 # Check if $USER_NAME SSH (v2) public key file exists
452 454 if [ -n "$SSH_USER_PUB_KEY" ] ; then
453 455 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
454 456 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
455 457 exit 1
456 458 fi
457 459 fi
458 460
459 461 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
460 462 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
461 463 exit 1
462 464 fi
463 465
464 466 # Check if all required packages are installed on the build system
465 467 for package in $REQUIRED_PACKAGES ; do
466 468 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
467 469 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
468 470 fi
469 471 done
470 472
471 473 # If there are missing packages ask confirmation for install, or exit
472 474 if [ -n "$MISSING_PACKAGES" ] ; then
473 475 echo "the following packages needed by this script are not installed:"
474 476 echo "$MISSING_PACKAGES"
475 477
476 478 printf "\ndo you want to install the missing packages right now? [y/n] "
477 479 read -r confirm
478 480 [ "$confirm" != "y" ] && exit 1
479 481
480 482 # Make sure all missing required packages are installed
481 483 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
482 484 fi
483 485
484 486 # Check if ./bootstrap.d directory exists
485 487 if [ ! -d "./bootstrap.d/" ] ; then
486 488 echo "error: './bootstrap.d' required directory not found!"
487 489 exit 1
488 490 fi
489 491
490 492 # Check if ./files directory exists
491 493 if [ ! -d "./files/" ] ; then
492 494 echo "error: './files' required directory not found!"
493 495 exit 1
494 496 fi
495 497
496 498 # Check if specified KERNELSRC_DIR directory exists
497 499 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
498 500 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
499 501 exit 1
500 502 fi
501 503
502 504 # Check if specified UBOOTSRC_DIR directory exists
503 505 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
504 506 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
505 507 exit 1
506 508 fi
507 509
508 510 # Check if specified VIDEOCORESRC_DIR directory exists
509 511 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
510 512 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
511 513 exit 1
512 514 fi
513 515
514 516 # Check if specified FBTURBOSRC_DIR directory exists
515 517 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
516 518 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
517 519 exit 1
518 520 fi
519 521
520 522 # Check if specified NEXMONSRC_DIR directory exists
521 523 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
522 524 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
523 525 exit 1
524 526 fi
525 527
526 528 # Check if specified CHROOT_SCRIPTS directory exists
527 529 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
528 530 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
529 531 exit 1
530 532 fi
531 533
532 534 # Check if specified device mapping already exists (will be used by cryptsetup)
533 535 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
534 536 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
535 537 exit 1
536 538 fi
537 539
538 540 # Don't clobber an old build
539 541 if [ -e "$BUILDDIR" ] ; then
540 542 echo "error: directory ${BUILDDIR} already exists, not proceeding"
541 543 exit 1
542 544 fi
543 545
544 546 # Setup chroot directory
545 547 mkdir -p "${R}"
546 548
547 549 # Check if build directory has enough of free disk space >512MB
548 550 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
549 551 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
550 552 exit 1
551 553 fi
552 554
553 555 set -x
554 556
555 557 # Call "cleanup" function on various signals and errors
556 558 trap cleanup 0 1 2 3 6
557 559
558 560 # Add required packages for the minbase installation
559 561 if [ "$ENABLE_MINBASE" = true ] ; then
560 562 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
561 563 fi
562 564
563 565 # Add parted package, required to get partprobe utility
564 566 if [ "$EXPANDROOT" = true ] ; then
565 567 APT_INCLUDES="${APT_INCLUDES},parted"
566 568 fi
567 569
568 570 # Add dbus package, recommended if using systemd
569 571 if [ "$ENABLE_DBUS" = true ] ; then
570 572 APT_INCLUDES="${APT_INCLUDES},dbus"
571 573 fi
572 574
573 575 # Add iptables IPv4/IPv6 package
574 576 if [ "$ENABLE_IPTABLES" = true ] ; then
575 577 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
576 578 fi
577 579 # Add apparmor for KERNEL_SECURITY
578 580 if [ "$KERNEL_SECURITY" = true ] ; then
579 581 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
580 582 fi
581 583
582 584 # Add openssh server package
583 585 if [ "$ENABLE_SSHD" = true ] ; then
584 586 APT_INCLUDES="${APT_INCLUDES},openssh-server"
585 587 fi
586 588
587 589 # Add alsa-utils package
588 590 if [ "$ENABLE_SOUND" = true ] ; then
589 591 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
590 592 fi
591 593
592 594 # Add rng-tools package
593 595 if [ "$ENABLE_HWRANDOM" = true ] ; then
594 596 APT_INCLUDES="${APT_INCLUDES},rng-tools"
595 597 fi
596 598
597 599 # Add fbturbo video driver
598 600 if [ "$ENABLE_FBTURBO" = true ] ; then
599 601 # Enable xorg package dependencies
600 602 ENABLE_XORG=true
601 603 fi
602 604
603 605 # Add user defined window manager package
604 606 if [ -n "$ENABLE_WM" ] ; then
605 607 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
606 608
607 609 # Enable xorg package dependencies
608 610 ENABLE_XORG=true
609 611 fi
610 612
611 613 # Add xorg package
612 614 if [ "$ENABLE_XORG" = true ] ; then
613 615 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
614 616 fi
615 617
616 618 # Replace selected packages with smaller clones
617 619 if [ "$ENABLE_REDUCE" = true ] ; then
618 620 # Add levee package instead of vim-tiny
619 621 if [ "$REDUCE_VIM" = true ] ; then
620 622 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
621 623 fi
622 624
623 625 # Add dropbear package instead of openssh-server
624 626 if [ "$REDUCE_SSHD" = true ] ; then
625 627 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
626 628 fi
627 629 fi
628 630
629 631 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
630 632 if [ "$ENABLE_SYSVINIT" = false ] ; then
631 633 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
632 634 fi
633 635
634 636 # Configure kernel sources if no KERNELSRC_DIR
635 637 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
636 638 KERNELSRC_CONFIG=true
637 639 fi
638 640
639 641 # Configure reduced kernel
640 642 if [ "$KERNEL_REDUCE" = true ] ; then
641 643 KERNELSRC_CONFIG=false
642 644 fi
643 645
644 646 # Configure qemu compatible kernel
645 647 if [ "$ENABLE_QEMU" = true ] ; then
646 648 DTB_FILE=vexpress-v2p-ca15_a7.dtb
647 649 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
648 650 KERNEL_DEFCONFIG="vexpress_defconfig"
649 651 if [ "$KERNEL_MENUCONFIG" = false ] ; then
650 652 KERNEL_OLDDEFCONFIG=true
651 653 fi
652 654 fi
653 655
654 656 # Execute bootstrap scripts
655 657 for SCRIPT in bootstrap.d/*.sh; do
656 658 head -n 3 "$SCRIPT"
657 659 . "$SCRIPT"
658 660 done
659 661
660 662 ## Execute custom bootstrap scripts
661 663 if [ -d "custom.d" ] ; then
662 664 for SCRIPT in custom.d/*.sh; do
663 665 . "$SCRIPT"
664 666 done
665 667 fi
666 668
667 669 # Execute custom scripts inside the chroot
668 670 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
669 671 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
670 672 chroot_exec /bin/bash -x <<'EOF'
671 673 for SCRIPT in /chroot_scripts/* ; do
672 674 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
673 675 $SCRIPT
674 676 fi
675 677 done
676 678 EOF
677 679 rm -rf "${R}/chroot_scripts"
678 680 fi
679 681
680 682 # Remove c/c++ build environment from the chroot
681 683 chroot_remove_cc
682 684
683 685 # Generate required machine-id
684 686 MACHINE_ID=$(dbus-uuidgen)
685 687 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
686 688 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
687 689
688 690 # APT Cleanup
689 691 chroot_exec apt-get -y clean
690 692 chroot_exec apt-get -y autoclean
691 693 chroot_exec apt-get -y autoremove
692 694
693 695 # Unmount mounted filesystems
694 696 umount -l "${R}/proc"
695 697 umount -l "${R}/sys"
696 698
697 699 # Clean up directories
698 700 rm -rf "${R}/run/*"
699 701 rm -rf "${R}/tmp/*"
700 702
701 703 # Clean up files
702 704 rm -f "${ETC_DIR}/ssh/ssh_host_*"
703 705 rm -f "${ETC_DIR}/dropbear/dropbear_*"
704 706 rm -f "${ETC_DIR}/apt/sources.list.save"
705 707 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
706 708 rm -f "${ETC_DIR}/*-"
707 709 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
708 710 rm -f "${ETC_DIR}/resolv.conf"
709 711 rm -f "${R}/root/.bash_history"
710 712 rm -f "${R}/var/lib/urandom/random-seed"
711 713 rm -f "${R}/initrd.img"
712 714 rm -f "${R}/vmlinuz"
713 715 rm -f "${R}${QEMU_BINARY}"
714 716
715 717 if [ "$ENABLE_QEMU" = true ] ; then
716 718 # Setup QEMU directory
717 719 mkdir "${BASEDIR}/qemu"
718 720
719 721 # Copy kernel image to QEMU directory
720 722 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
721 723
722 724 # Copy kernel config to QEMU directory
723 725 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
724 726
725 727 # Copy kernel dtbs to QEMU directory
726 728 for dtb in "${BOOT_DIR}/"*.dtb ; do
727 729 if [ -f "${dtb}" ] ; then
728 730 install_readonly "${dtb}" "${BASEDIR}/qemu/"
729 731 fi
730 732 done
731 733
732 734 # Copy kernel overlays to QEMU directory
733 735 if [ -d "${BOOT_DIR}/overlays" ] ; then
734 736 # Setup overlays dtbs directory
735 737 mkdir "${BASEDIR}/qemu/overlays"
736 738
737 739 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
738 740 if [ -f "${dtb}" ] ; then
739 741 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
740 742 fi
741 743 done
742 744 fi
743 745
744 746 # Copy u-boot files to QEMU directory
745 747 if [ "$ENABLE_UBOOT" = true ] ; then
746 748 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
747 749 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
748 750 fi
749 751 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
750 752 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
751 753 fi
752 754 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
753 755 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
754 756 fi
755 757 fi
756 758
757 759 # Copy initramfs to QEMU directory
758 760 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
759 761 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
760 762 fi
761 763 fi
762 764
763 765 # Calculate size of the chroot directory in KB
764 766 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
765 767
766 768 # Calculate the amount of needed 512 Byte sectors
767 769 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
768 770 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
769 771 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
770 772
771 773 # The root partition is EXT4
772 774 # This means more space than the actual used space of the chroot is used.
773 775 # As overhead for journaling and reserved blocks 35% are added.
774 776 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
775 777
776 778 # Calculate required image size in 512 Byte sectors
777 779 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
778 780
779 781 # Prepare image file
780 782 if [ "$ENABLE_SPLITFS" = true ] ; then
781 783 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
782 784 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
783 785 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
784 786 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
785 787
786 788 # Write firmware/boot partition tables
787 789 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
788 790 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
789 791 EOM
790 792
791 793 # Write root partition table
792 794 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
793 795 ${TABLE_SECTORS},${ROOT_SECTORS},83
794 796 EOM
795 797
796 798 # Setup temporary loop devices
797 799 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
798 800 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
799 801 else # ENABLE_SPLITFS=false
800 802 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
801 803 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
802 804
803 805 # Write partition table
804 806 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
805 807 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
806 808 ${ROOT_OFFSET},${ROOT_SECTORS},83
807 809 EOM
808 810
809 811 # Setup temporary loop devices
810 812 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
811 813 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
812 814 fi
813 815
814 816 if [ "$ENABLE_CRYPTFS" = true ] ; then
815 817 # Create dummy ext4 fs
816 818 mkfs.ext4 "$ROOT_LOOP"
817 819
818 820 # Setup password keyfile
819 821 touch .password
820 822 chmod 600 .password
821 823 echo -n ${CRYPTFS_PASSWORD} > .password
822 824
823 825 # Initialize encrypted partition
824 826 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
825 827
826 828 # Open encrypted partition and setup mapping
827 829 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
828 830
829 831 # Secure delete password keyfile
830 832 shred -zu .password
831 833
832 834 # Update temporary loop device
833 835 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
834 836
835 837 # Wipe encrypted partition (encryption cipher is used for randomness)
836 838 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
837 839 fi
838 840
839 841 # Build filesystems
840 842 mkfs.vfat "$FRMW_LOOP"
841 843 mkfs.ext4 "$ROOT_LOOP"
842 844
843 845 # Mount the temporary loop devices
844 846 mkdir -p "$BUILDDIR/mount"
845 847 mount "$ROOT_LOOP" "$BUILDDIR/mount"
846 848
847 849 mkdir -p "$BUILDDIR/mount/boot/firmware"
848 850 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
849 851
850 852 # Copy all files from the chroot to the loop device mount point directory
851 853 rsync -a "${R}/" "$BUILDDIR/mount/"
852 854
853 855 # Unmount all temporary loop devices and mount points
854 856 cleanup
855 857
856 858 # Create block map file(s) of image(s)
857 859 if [ "$ENABLE_SPLITFS" = true ] ; then
858 860 # Create block map files for "bmaptool"
859 861 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
860 862 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
861 863
862 864 # Image was successfully created
863 865 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
864 866 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
865 867 else
866 868 # Create block map file for "bmaptool"
867 869 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
868 870
869 871 # Image was successfully created
870 872 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
871 873
872 874 # Create qemu qcow2 image
873 875 if [ "$ENABLE_QEMU" = true ] ; then
874 876 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
875 877 QEMU_SIZE=16G
876 878
877 879 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
878 880 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
879 881
880 882 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
881 883 fi
882 884 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant